{    pp 2 }
(***********************************)
(* Used  from GrafDemo             *)
(* This Unit provide object, wich  *)
(* draw Sierpinski line            *)
(***********************************)
Unit Sierpinski;

interface
uses Objects;
type
  TSierpinski = object(TObject)

     procedure A(k,Size: word);
     procedure B(k,Size: word);
     procedure C(k,Size: word);
     procedure D(k,Size: word);
     procedure LineRel(dx,dy: integer); virtual;
     procedure Draw(K: Integer); virtual;
  end;
procedure Wait(Delay: byte);

implementation
uses Graph;

procedure Wait(Delay: byte);
var
  i,j: integer;
var
  Ticks: LongInt absolute $40:$6C;
  OldTicks: LongInt;
begin
  OldTicks := Ticks;
  while OldTicks + Delay > Ticks do ;
end;

procedure TSierpinski.LineRel(dx,dy: integer);
begin
  Graph.LineRel(dx,dy);
  wait(1);
end;

procedure TSierpinski.A(k,Size: word);
begin
  if k > 0 then begin
     A(k-1,Size);LineRel(Size,Size);
     B(k-1,Size);LineRel(2*Size,0);
     D(k-1,Size);LineRel(Size,-Size);
     A(k-1,Size);
  end;
end;
procedure TSierpinski.B(k,Size: word);
begin
  if k > 0 then begin
     B(k-1,Size);LineRel(-Size,Size);
     C(k-1,Size);LineRel(0,2*Size);
     A(k-1,Size);LineRel(Size,Size);
     B(k-1,Size);
  end;
end;
procedure TSierpinski.C(k,Size: word);
begin
  if k > 0 then begin
     C(k-1,Size);LineRel(-Size,-Size);
     D(k-1,Size);LineRel(-2*Size,0);
     B(k-1,Size);LineRel(-Size,Size);
     C(k-1,Size);
  end;
end;
procedure TSierpinski.D(k,Size: word);
begin
  if k > 0 then begin
     D(k-1,Size);LineRel(Size,-Size);
     A(k-1,Size);LineRel(0,-2*Size);
     C(k-1,Size);LineRel(-Size,-Size);
     D(k-1,Size);
  end;
end;

procedure TSierpinski.Draw;
var
  h,i,akkamulator: integer;
  x0,y0: Integer;

begin
    h := 96;
    akkamulator := 0;

    for i := 1 to K  do begin
        akkamulator := akkamulator + h;
        h := h div 2;
    end;
    x0 := 320 - akkamulator;
    y0 := 240 - akkamulator - h;

    MoveTo(X0,Y0);

    A(K,h);LineRel(h,h);
    B(K,h);LineRel(-h,h);
    C(K,h);LineRel(-h,-h);
    D(K,h);LineRel(h,-h);
end;

end.
